<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Plugins Docs Source: d-pro/d-pro.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Plugins Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="modules.list.html" class="dropdown-toggle" data-toggle="dropdown">Modules<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-ableton_ableton.html">ableton/ableton</a></li><li><a href="module-control_control.html">control/control</a></li><li><a href="module-d-pro_d-pro.html">d-pro/d-pro</a></li><li><a href="module-data_data.html">data/data</a></li><li><a href="module-devices_device.html">devices/device</a></li><li><a href="module-devices_devices.html">devices/devices</a></li><li><a href="module-logic_logic.html">logic/logic</a></li><li><a href="module-messenger.html">messenger</a></li><li><a href="module-plugin.html">plugin</a></li><li><a href="module-sound_sound.html">sound/sound</a></li><li><a href="module-telegram_client.html">telegram/client</a></li><li><a href="module-telegram_telegram.html">telegram/telegram</a></li><li><a href="module-time_time.html">time/time</a></li><li><a href="module-tradfri_tradfri.html">tradfri/tradfri</a></li><li><a href="module-twilio_phone.html">twilio/phone</a></li><li><a href="module-twilio_twilio.html">twilio/twilio</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-ableton_ableton-Liveset.html">ableton/ableton~Liveset</a></li><li><a href="module-control_control-SessionControl.html">control/control~SessionControl</a></li><li><a href="module-d-pro_d-pro-Show.html">d-pro/d-pro~Show</a></li><li><a href="module-data_data-Data.html">data/data~Data</a></li><li><a href="module-data_data-CollectionAPI.html">data/data~CollectionAPI</a></li><li><a href="module-devices_device-Device.html">devices/device~Device</a></li><li><a href="module-devices_device-UDPdevice.html">devices/device~UDPdevice</a></li><li><a href="module-devices_device-OSCdevice.html">devices/device~OSCdevice</a></li><li><a href="module-devices_device-TCPdevice.html">devices/device~TCPdevice</a></li><li><a href="module-devices_device-Webdevice.html">devices/device~Webdevice</a></li><li><a href="module-devices_device-Serialdevice.html">devices/device~Serialdevice</a></li><li><a href="module-devices_device-Mididevice.html">devices/device~Mididevice</a></li><li><a href="module-logic_logic-Logic.html">logic/logic~Logic</a></li><li><a href="module-logic_logic-Condition.html">logic/logic~Condition</a></li><li><a href="module-logic_logic-Listener.html">logic/logic~Listener</a></li><li><a href="module-logic_logic-PEventListener.html">logic/logic~PEventListener</a></li><li><a href="module-messenger-Messenger.html">messenger~Messenger</a></li><li><a href="module-messenger-Conversation.html">messenger~Conversation</a></li><li><a href="module-messenger-Agent.html">messenger~Agent</a></li><li><a href="module-plugin-Plugin.html">plugin~Plugin</a></li><li><a href="module-plugin-Collection.html">plugin~Collection</a></li><li><a href="module-plugin-Item.html">plugin~Item</a></li><li><a href="module-telegram_client-Agent.html">telegram/client~Agent</a></li><li><a href="module-telegram_client-Client.html">telegram/client~Client</a></li><li><a href="module-telegram_client-Bot.html">telegram/client~Bot</a></li><li><a href="module-telegram_telegram-Telegram.html">telegram/telegram~Telegram</a></li><li><a href="module-telegram_telegram-Conversation.html">telegram/telegram~Conversation</a></li><li><a href="module-telegram_telegram-Dialogue.html">telegram/telegram~Dialogue</a></li><li><a href="module-telegram_telegram-DialogueCondition.html">telegram/telegram~DialogueCondition</a></li><li><a href="module-telegram_telegram-Chat.html">telegram/telegram~Chat</a></li><li><a href="module-telegram_telegram-Message.html">telegram/telegram~Message</a></li><li><a href="module-twilio_phone-Phone.html">twilio/phone~Phone</a></li><li><a href="module-twilio_twilio-Switchboard.html">twilio/twilio~Switchboard</a></li><li><a href="module-twilio_twilio-SmsIn.html">twilio/twilio~SmsIn</a></li><li><a href="module-twilio_twilio-Call.html">twilio/twilio~Call</a></li><li><a href="module-twilio_twilio-CallIn.html">twilio/twilio~CallIn</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: d-pro/d-pro.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* Connect to D-Pro Light Control Software using OSC commands
*
* @requires device
*
* @module d-pro/d-pro
* @copyright Lasse Marburg 2020
* @license GPLv3
*/

const device = require("../devices/device.js")
const plugin = require("../plugin.js")

var schema = {
  "cue": {
  },
  "collections": {
    "shows": {
      "type": "object",
      "title": "D-Pro Show",
      "properties": {
        "settings": {
          "type": "object",
          "description": "set the connection properties for this device",
          "required": true,
          "properties": {
            "port": {
              "type": "number",
              "default": 0,
              "required": true,
              "description": "port the device communicates with the plai framework on. 0 to set random port"
            },
            "ip": {
              "type": "string",
              "description": "the ip address of your device so the framework can send messages to it.",
              "default": "0.0.0.0"
            },
            "framework_port": {
              "type": "number",
              "description": "define a different port the device sends data to the framework on if needed."
            },
            "path": {
              "type": "string",
              "descrption": "prepend an OSC formatted address for every message sent by OSC device"
            }
          }
        }
      }
    }
  }
}



class DPro extends plugin.Plugin {
  constructor() {
    super(schema)
  }

  /**
  * overwrite plugin add function:
  * - add a new Show instance with every added collection
  * - set collection to shows because Show extends from OSCdevice which would otherwise default to device collection for data storage
  * - add show property to cue schema
  *
  * overwrite plugin remove function
  * - remove the show instance
  * - remove its schema properties from the schema
  *
  */
  setup(config) {
    super.setup(config)
      .then(function (result) {
        this.shows.add = function (data) {
          schema.cue[data.name] = {
            "type": "array",
            "items": {
              "type": "object",
              "properties": {}
            },
            "default": [{}]
          }
          data["collection"] = "shows"
          this.shows.items[data.name] = new Show(data, this.db, this.db.shows.document({ "name": data.name }), this.showChanges.bind(this))
        }.bind(this)
        this.shows.remove = function (name) {
          this.shows.items[name].close()
          delete this.shows.items[name]
          delete schema.cue[name]
          this.schemaUpdate(schema)
          log.debug(this.name, "Show removed: " + name)
        }.bind(this)
        this.shows.collectItems()
      }.bind(this))
      .catch(function (error) {
        log.error("D-Pro", error)
      }.bind(this))

    return schema
  }

  cue(data) {
    return new Promise((resolve, reject) => {
      let promises = []
      for (let d in data) {
        if (this.shows.items.hasOwnProperty(d)) {
          promises.push(this.shows.items[d].send(data[d]))
        } else {
          log.error(this.name, "no D-Pro show called " + d)
        }
      }
      Promise.all(promises)
      .then(result => {
        return resolve()
      })
      .catch(err => {
        return reject(err)
      })
    })
  }

  command(input) {
    switch (input[0]) {
      case "shows":
        for (let show in this.shows.items) {
          log.info(this.name, show)
        }
        break
      default:
        super.command(input)
        break
    }
  }

  showChanges(changes, show) {
    for (let change in changes) {
      if (change == "schema") {
        schema.cue[show].items.properties = changes[change]
        this.schemaUpdate(schema)
      }
    }
  }
}

/**
* OSC connection to Enttec D-Pro Light Software
*
* registers mapping from d-pro show and converts it to cue shema for level design
* including all cues, snap etc. the d-pro show has to offer
*
* @param {Object} config - device config data. see device.OSCdevice
* @param {Document} device_doc - mongodb document connector
* @param {function} callback - to report schema changes to d-pro plugin
*/
class Show extends device.OSCdevice {
  constructor(config, db, device_doc, callback) {
    super(config, db)
    this.doc = device_doc
    this.mapping = { "btn": {}, "snap": {}, "fade": {} }
    this.callback = callback

    this.doc.get()
      .then(function (data) {
        if (data.hasOwnProperty('mapping')) {
          this.mapping = data.mapping
          this.schemaUpdate()
        }
      }.bind(this))
      .catch(function (err) {
        log.error(this.name, err)
      }.bind(this))

    /** d-pro show properties */
    this.schema = {
      "btn": {
        "title": "cue",
        "type": "object",
        "description": "Run a cue or cuelist.",
        "properties": {}
      },
      "snap": {
        "title": "snapshot",
        "type": "string",
        "description": "Run a snapshot.",
        "enum": []
      },
      "fade": {
        "title": "fade",
        "type": "object",
        "description": "Run the cue or cuelist with the specified level.",
        "properties": {}
      },
      "reset": {
        "type": "boolean",
        "description": "stop all active cues &amp; cuelists",
        "default": true
      },
      "master": {
        "type": "number",
        "format": "range",
        "minimum": 0.0,
        "maximum": 1.0,
        "step": 0.01,
        "descripton": "set the grand master level"
      },
      "speed": {
        "type": "number",
        "minimum": 0.25,
        "maximum": 4.0,
        "format": "range",
        "step": 0.01,
        "descripton": "set the global speed"
      },
      "tempo": {
        "type": "number",
        "minimum": 30.0,
        "maximum": 480.0,
        "format": "range",
        "step": 1,
        "descrption": "set the global speed using a tempo"
      }
    }

    this.schemaUpdate()
  }

  async send(msg) {
    let snd = {}
    for (let item in msg) {
      switch (item) {
        case 'btn':
          for (let btn in msg[item]) {
            snd[this.mapping.btn[btn]] = msg[item][btn]
          }
          break

        case 'snap':
          snd[this.mapping.snap[msg[item]]] = 1
          break

        case 'fade':
          for (let fade in msg[item]) {
            snd[this.mapping.fade[fade]] = msg[item][fade]
          }
          break

        case 'reset':
          snd['sc/reset'] = 1
          break

        case 'master':
          snd['sc/gm'] = msg[item]
          break

        case 'speed':
          snd['sc/speed'] = msg[item]
          break

        case 'tempo':
          snd['sc/tempo'] = msg[item]
          break
      }
      await super.send(snd)
    }
    return
  }

  /**
  * middle route function to catch and map all label assignments from d-pro
  *
  * remove empty label addresses
  */
  route(osc_msg) {
    if (osc_msg.address.match(/label/g)) {
      let path = osc_msg.address.split('/')
      if (path.length > 2) {
        if (osc_msg.args[0].value == '') {
          if (this.mapping.hasOwnProperty(path[2])) {

            for (let map in this.mapping[path[2]]) {
              if (this.mapping[path[2]][map] == osc_msg.address.replace(/label/g, 'run').substring(1)) {
                delete this.mapping[path[2]][map]
                //log.info(this.name, "remove", osc_msg.address.replace(/label/g, 'run'))
                return null
              }
            }
          }
        } else {
          let addr = osc_msg.address.replace(/label/g, 'run')
          addr = addr.substring(1) // remove leading '/'
          if (this.mapping.hasOwnProperty(path[2])) {

            if (this.mapping[path[2]].hasOwnProperty(osc_msg.args[0].value)) {
              if (this.mapping[path[2]][osc_msg.args[0].value] == addr) {
                return null
              } else {
                log.debug(this.name, "add to mapping:", osc_msg.args[0].value, addr)
                this.mapping[path[2]][osc_msg.args[0].value] = addr
              }
            } else {
              log.debug(this.name, "add to mapping:", osc_msg.args[0].value, addr)
              this.mapping[path[2]][osc_msg.args[0].value] = addr
            }
          }
        }
        this.doc.set({ mapping: this.mapping })
        this.schemaUpdate()
        return null
      }

    } else {
      return super.route(osc_msg)
    }
  }

  schemaUpdate() {
    // BTN
    this.schema.btn.properties = {}
    for (let btn in this.mapping.btn) {
      if (!this.schema.btn.properties.hasOwnProperty(btn)) {
        this.schema.btn.properties[btn] = { "type": "integer", "enum": [0, 1], "default": 1 }
      }
    }
    //SNAP
    this.schema.snap.enum = []
    for (let snap in this.mapping.snap) {
      if (!this.schema.snap.enum.includes(snap)) {
        this.schema.snap.enum.push(snap)
      }
    }
    // FADE
    this.schema.fade.properties = {}
    for (let fade in this.mapping.fade) {
      if (!this.schema.fade.properties.hasOwnProperty(fade)) {
        this.schema.fade.properties[fade] = { "type": "number", "format": "range", "step": 0.01, "minimum": 0.0, "maximum": 1.0, }
      }
    }
    //this.doc.set({"schema":this.schema})
    this.callback({ "schema": this.schema }, this.name)
  }
}

module.exports.Plugin = DPro
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/webview/'>Webview Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
